<?php
if(!class_exists('Gc_Option_Namespace')) {
	class Gc_Option_Namespace{
		protected $namespace;
		protected $options;
		public function __construct($namespace = "gc_"){
			$this->namespace = $namespace;
		}

		public function load_from_array($config){
			foreach ($config as $key => $value) {
				$option = new Gc_Option();
				$option->load_from_array($value);
				$this->options[$key] = $option;
			}
		}

		public function get($key){
			if(isset($this->options[$key])){
				return $this->options[$key]->load();
			}
			return new Gc_Option($key);
		}

		public function get_options(){
			return $this->options;
		}

	    public function filter_options_by_type($type_name){
	        return $this->filter("get_type", $type_name);
	    }


	    public function filter_options_by_group($group_name){
	        return $this->filter("get_group", $group_name);
	    }

	    public function filter($filter_name,$filter_value){
	        $filtered_options = array();
	        $options = $this->get_options();
	        foreach ($options as $key => $opt) {
	            if($opt->$filter_name() == $filter_value){
	                $filtered_options[$key] = $opt;
	            }
	        }
	        return $filtered_options;
	    }

		
	}
}
